/************************************/
/* ECE565 Project - Winter 2001     */
/*                                  */
/* Encrypted FTP Program            */
/*                                  */
/* Don Heer 541-19-6429             */
/* Reto Galli 930-28-0969           */
/************************************/

#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <time.h>
#include "cylink.h"
#include "toolkit.h"
#include <sys/stat.h>

/* This structure is what houses my fram data. */

volatile sig_atomic_t done;

void inthandler(int Sig)
{
done = 1;
}

uchar DH_base[64] =
	 { 0xc9, 0x07, 0x86, 0xbf, 0x92, 0x6c, 0x1e, 0x51,
       0xa5, 0xb6, 0xe6, 0xe1, 0x9d, 0x0b, 0xc6, 0x50,
       0xab, 0x49, 0x77, 0xe6, 0x3c, 0xc7, 0x32, 0x1c,
       0x3f, 0x24, 0xb3, 0x2d, 0xd6, 0x22, 0x40, 0x01,
	   0x32, 0x19, 0x34, 0x35, 0x15, 0xdf, 0xa5, 0x63,
       0x33, 0xe1, 0x35, 0xc1, 0x7e, 0x98, 0xf1, 0x92,
       0x0f, 0xc5, 0x6c, 0xf4, 0x3f, 0x73, 0x4e, 0xf6,
       0x9d, 0x9d, 0xf5, 0xd0, 0xd6, 0x06, 0x9a, 0x3c};

uchar DH_modulus[64] =
     { 0xff, 0xe2, 0x14, 0x9a, 0xfd, 0xcd, 0x25, 0x47,
       0x1c, 0xaf, 0x1a, 0x7c, 0xd4, 0xeb, 0xdd, 0xf8,
       0xc0, 0x88, 0x66, 0xbe, 0xf2, 0x61, 0xb6, 0xe5,
       0x1f, 0x2b, 0xf0, 0x5c, 0xb4, 0x94, 0x9d, 0xa9,
       0x30, 0x85, 0xe4, 0xe4, 0xed, 0x4d, 0x4d, 0xcb,
       0x2a, 0xe4, 0x7e, 0x5f, 0x6e, 0xef, 0x39, 0xf9,
       0xb5, 0xb6, 0xca, 0x25, 0x5f, 0xcf, 0x3b, 0x2f,
	   0x70, 0x8b, 0xa0, 0x64, 0x72, 0xa8, 0x49, 0xfb};

typedef struct{
	unsigned int control;
	unsigned char block[64];
	} frame;

/* This function allows me to check a socket for data, with out advancing the pointer */

int CheckForData(int socket_id)
	{
	struct timeval tv;
	fd_set read_fd;
	tv.tv_sec = 0;
	tv.tv_usec = 0;
	FD_ZERO(&read_fd);
	FD_SET(socket_id, &read_fd);
	if (select(socket_id+1, &read_fd, NULL, NULL, &tv)== -1)
	  {
	  return 0;
	  }
	if (FD_ISSET(socket_id, &read_fd))
	  {
	  return 1;
	  }
	return 0;
	}

unsigned int get_file_size(filename)
char* filename;
{
   struct stat file_stat;

   if ( -1 ==  stat (filename, &file_stat))
   {
      printf(" Error occoured attempting to stat %s\n", filename);
      return 0;
   }

   return (unsigned int) file_stat.st_size;   
}

int main()
	{
/**************************************************************************/
// File Pointers and Char Pointers
/**************************************************************************/
	FILE *fp, *fp2, *fp3;
	char portnumberstr[64] = "6429";
	char junk[25] = {0};
	char hostname[64] = {0};
	
/**************************************************************************/
// Transmission Varibles
/**************************************************************************/
	frame data;
	unsigned char datastring[68];
	int new_fd = 0, complete = 0, pid, filedone, retries, ack;
	unsigned int i, filesize, step, last;

/**************************************************************************/
// Connection Varibles
/**************************************************************************/
	struct sockaddr_in my_addr;
	struct sockaddr_in client_addr;
	int sin_size;
	int socket_id;
	struct hostent *he;
	struct sockaddr_in host_addr;
	unsigned short portnumber = 6429;

/**************************************************************************/
// Encryption Varibles.	
/**************************************************************************/
	uchar RVAL [SHA_LENGTH];
	uchar DH_public_A [64];
        uchar DH_secret_A [64];
	uchar DH_public_B [64];
        uchar DH_secret_B [64];
        uchar DH_shared_A [64];
        uchar DH_shared_B [64];
	uchar Key_A [8];
        uchar Key_B [8];
        uchar DES_Key_A [128];
        uchar DES_Key_B [128];
        uchar key_iv[8]={0x12,0x34,0x56,0x78,0x90,0xab,0xcd,0xef};
        int status = SUCCESS;      /* function return status */
        uchar seed[]="This is the initialization vector";
        
        
	printf("\n\nWelcome to the Heerian/Galliian Encrypted FTP Program.\n\n");	
	printf("This program works as both a sender and reciever system.\n");
	printf("First the user selcets if they are going to connect to another\n");
	printf("system, or if they want to open the program to recieve a connection.\n");
	printf("If they choose to initiate a connection, they are then prompted for\n");
	printf("a hostname (eg. holmes.ece.orst.edu) and a port number greater than\n");
	printf("1024 (eg. 6429). After connection, a menu is displayed, and options can\n");
	printf("selected.\n\n");
	printf("Will this process initiate a new connection (Y or N) -> ");
	scanf("%s", junk);
	if (junk[0] != 'Y' && junk[0] != 'y' && junk[0] != 'N' && junk[0] != 'n')
	   {
	   printf("\n\nSorry, %s is not a valid selection.\n", junk);
	   return 1;
	   }
	printf("\n\n");
	if ( junk[0] == 'Y' || junk[0] == 'y' )
	   {
	   printf("Please enter host name (64 chars max)-> ");
	   scanf("%s", hostname);
	   printf("Now please enter the port number (greater than 1024) -> ");
	   scanf("%s", portnumberstr);
	   printf("\n\n");
	   portnumber = atoi(portnumberstr);
// Validate port number.
	   if (portnumber < 1024)
	      {
	      printf("Sorry invalid port number. CLOSING\n");
	      return 1;
	      }
	
// Generate IP address.	
	   if ((he = (struct hostent *)(gethostbyname(hostname))) == NULL)
	      {
	      printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! HOST NOT FOUND\n");
	      printf("Host %s could not be located.\n", hostname);
	      return 1;
	      }
// Make Socket	
	   if ((socket_id = socket(AF_INET, SOCK_STREAM, 0)) == -1)
	      {
	      printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! SOCKET NOT CREATED\n");
	      return 1;
	      }
	   host_addr.sin_family = AF_INET;
	   host_addr.sin_port = htons(portnumber);
	   host_addr.sin_addr = *((struct in_addr *)he->h_addr);
	   memset(host_addr.sin_zero, 0, sizeof host_addr.sin_zero);
// Connect to reciever.	
	   if (connect(socket_id, (struct sockaddr *)&host_addr, sizeof(struct sockaddr)) == -1)
	      {
	      printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! HOST NOT CONNECTABLE\n");
	      printf("%s could not be connected to.\n", hostname);
	      return 1;
	      }
	   printf("Connected Succseccfully!!\n");
	   }
	else
	   {
	   my_addr.sin_family = AF_INET;
	   my_addr.sin_addr.s_addr = INADDR_ANY;
	   my_addr.sin_port = htons(portnumber);
	   memset(my_addr.sin_zero, 0, sizeof my_addr.sin_zero);
// Set Up socket
           if ((new_fd = socket(AF_INET, SOCK_STREAM, 0)) == -1)
	      {
	      printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! SOCKET NOT CREATED\n");
	      return 1;
	      }
// Bind socket	
	   if (bind(new_fd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1)
	      {
	      printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! SOCKET NOT CREATED\n");
	      return 1;
	      }
	   printf("Beginning to listen to port %d\n", portnumber);
// Listen to Socket	
	   if (listen(new_fd, 4) == -1)
	      {
	      printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! SOCKET NOT CREATED\n");
	      shutdown(new_fd, 2);
	      return 1;
	      }
// Loop for connection
	   while(!done && !complete)
	      {
	      if (0 != CheckForData(new_fd))
	         {
		 printf("Data detected on port %d\n", portnumber);
		 sin_size = sizeof(struct sockaddr_in);
		 if ((socket_id = accept(new_fd, &client_addr, &sin_size)) == -1)
		    {
		    printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! ACCEPT BROKEN\n");
		    return 1;
		    continue;
		    }
		 else 
		    {
		    printf("Connection Established!!!\n\n");
		    complete = 1;
		    }
		 }
	      }
	   }
	complete = 0;
	
// Menu Display	
	system("clear");
	printf("\nHere is the menu!!\nThis should redisplay after every command.\n");
	printf("Options are:\n\t'q' - Quit both machines\n\t's' - Send File\n\t");
	printf("'e' - Encrypted File Send\n\t'd' - Decrypt Sent File\n\t -> ");
	while(!done && !complete)
	      {
/*****************************************************************************/
/*
	Here is the core of the non-blocking program. This if statement is 
	housed in a while loop the repats until the program exits. The if
	checks for data presence first on the socket (Recieve Mode) and then
	second on the Standard Input (Transmit Mode). Based on the prsence
	of this data, we enter either of these modes 
*/
/*****************************************************************************/
// Recieve Mode	      
	      
	      if (CheckForData(socket_id) != 0) 
	         {
	         printf("\n\n**********************\nIncoming Transmission.\n**********************\n\n");
	         if (recv(socket_id, datastring, sizeof datastring, 0) == -1)
	   	    {
		    printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! RECV BROKEN (1)\n");
		    return 1;
		    }
	         switch (((unsigned int*)datastring)[0])
	            {

// Remote Request for QUIT
	            case 1234:
	            printf("Entering State 1234 - Quit State, Remote Request\n\n");
	            done = 1;
	            break;
	            
// Remote Request for File Send	            
	            case 1235:
	            printf("Entering State 1235 - Incoming File\n\n");
	            filedone = 0;
	            i = 0;
	            while ( i < 64)
	               {
	               hostname[i] = datastring[i+4];
	               i++;
	               }
	            printf("The incoming file will be named %s.\n", hostname);
	            ((unsigned int *)datastring)[0] = 0;
	            if((fp = fopen(hostname, "wb")) == NULL)
		       {
		       printf("File %s could not be opened.\n", hostname);
		       ((unsigned int *)datastring)[0] = 1;
		       filedone = 1;
		       }
	            if (send(socket_id, datastring, sizeof datastring, 0) == NULL)
	               {
	               printf("RECIEVE IS BROKEN. (1)\n\n");
	               return 1;
	               }
	            
// Recieve and Write file.	            
	            while (!filedone)
		       {
	               if (recv(socket_id, datastring, sizeof datastring, 0) == NULL)
	                  {
	                  printf("RECIEVE IS BROKEN. (1)\n\n");
	                  return 1;
	                  }
	               i = 0;
	               while (i < 64)
	                  {
	                  data.block[i] = datastring[i+4];
	                  i++;
	                  }
	               fwrite(data.block, 1, ((unsigned int *)datastring)[0], fp);
	               if ( ((unsigned int *)datastring)[0] != 64 )
	                  {
	                  printf("The file has been completely recieved.\n");
	                  filedone = 1;
	                  fclose(fp);
	                  }
	               if (send(socket_id, datastring, sizeof datastring, 0) == NULL)
	                  {
	                  printf("RECIEVE IS BROKEN. (1)\n\n");
	                  return 1;
	                  }
	               }
	            break;
	            
// Remote Request for Encrypted File Send	            
	            case 1236:
	            printf("Entering State 1236 - Incoming Encrypted Transmission State.\n\n");
	            filedone = 0;
	            i = 0;
	            while ( i < 64)
	               {
	               hostname[i] = datastring[i+4];
	               i++;
	               }
	            printf("The incoming file will be named %s.\n", hostname);
	            ((unsigned int *)datastring)[0] = 0;
	            if((fp = fopen(hostname, "wb")) == NULL)
		       {
		       printf("File %s could not be opened.\n", hostname);
		       ((unsigned int *)datastring)[0] = 1;
		       filedone = 1;
		       }
	            printf("File %s opened for write.\n", hostname);
	            if (send(socket_id, datastring, sizeof datastring, 0) == NULL)
	               {
	               printf("RECIEVE IS BROKEN. (1)\n\n");
	               return 1;
	               }
	            
// Begin Generation of Session Key	            
	            printf("Generating the DH pair.\n");
	            if ( (status = GenDHPair( 64, DH_secret_B, DH_public_B,
         	      (uchar *)DH_base, (uchar *)DH_modulus, RVAL)) != SUCCESS)
    		       {
        	       printf("Can not generate DH pair.\n");
        	       return status;
    		       }
	            printf("Preparing to recieve public key.\n");
	            if ( recv(socket_id, DH_public_A, sizeof DH_public_A, 0) == NULL )
		          {
		          printf("recv() IS BROKEN (1)\n");
		          return 1;
		          }
	            printf("Preparing to send public key.\n");
	            if ( send(socket_id, DH_public_B, sizeof DH_public_B, 0) == NULL )
		          {
		          printf("send() IS BROKEN (1)\n");
		          return 1;
		          }
		    if ( (status = GetDHSharedNumber( 64, DH_secret_B, DH_public_A,
            	     DH_shared_B, (uchar *)DH_modulus)) != SUCCESS)
    		       {
        	       printf("Can not generated shared number.\n");
        	       return status;
    		       }
    		    if ( (status = SetCipherKey( 64, DH_shared_B, Key_B, DES56_ECB ))
                     !=SUCCESS)
    		       {
        	       printf("Can not set cipher key.\n");
        	       return status;
    		       }
		    DESKeyExpand( Key_B, DES_Key_B );
// Session Key Created
 		    
// Create 'Key' File. 		    
 		    strcat(hostname, ".key");
 		    if((fp3 = fopen(hostname, "wb")) == NULL)
		       {
		       printf("File %s could not be opened.\n", hostname);
		       ((unsigned int *)datastring)[0] = 1;
		       filedone = 1;
		       }
 		    fwrite(key_iv, 1, sizeof key_iv, fp3);
	            fwrite(DES_Key_B, 1, sizeof DES_Key_B, fp3);
	            fclose(fp3);
// Key file done.	            
	            
// Write file with encrypted packet data.	            
	            while (!filedone)
		       {
	               if (recv(socket_id, datastring, sizeof datastring, 0) == NULL)
	                  {
	                  printf("RECIEVE IS BROKEN. (1)\n\n");
	                  return 1;
	                  }
	               i = 0;
	               while (i < 64)
	                  {
	                  data.block[i] = datastring[i+4];
	                  i++;
	                  }
	               fwrite(((unsigned int *)datastring), 4, 1, fp);
	               fwrite(data.block, 1, 64, fp);
	               if ( ((unsigned int *)datastring)[0] != 64 )
	                  {
	                  printf("The file has been completely recieved.\n");
	                  filedone = 1;
	                  fclose(fp);
	                  }
	               if (send(socket_id, datastring, sizeof datastring, 0) == NULL)
	                  {
	                  printf("RECIEVE IS BROKEN. (1)\n\n");
	                  return 1;
	                  }
	               }
	            break;
	            }

// If not done, Redisplay Menu.
		 if (done != 1)
	            {
	            printf("\nPausing...\n\n");
		    system("sleep 4");
	            system("clear");
	            printf("Here is the menu!!\nThis should redisplay after every command.\n");
	            printf("Options are:\n\t'q' - Quit both machines\n\t's' - Send File\n\t");
	            printf("'e' - Encrypted File Send\n\t'd' - Decrypt Sent File. \n\t -> ");
	            }
	         }	
	      
// Enter Transmission Mode	      
	      else if (CheckForData(1) != 0)
	         {
	         scanf("%s",junk);
	         switch (junk[0])
	            {
	            
// Local Request For QUIT	            
	            case 'q':
	            printf("Entering Quit State - Local Request.\n\n");
	            ((unsigned int *)datastring)[0] = 1234;
	            if (send(socket_id, datastring, sizeof datastring, 0) == -1)
		    	{
		    	printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! SEND BROKEN\n");
		    	continue;
		    	}
	            done = 1;
	            break;
	            
// Local Request to Send file	            
	            case 's':
	            printf("Entering File Send Mode.\n\n");
	            printf("Please enter the file name to send -> ");
	            scanf("%s", hostname);
	            filedone = 0;
	            if((fp = fopen(hostname, "rb")) == NULL)
		       {
		       printf("File %s could not be opened.\n", hostname);
		       filedone = 1;
		       }
	            else
	               {
	               filesize = get_file_size(hostname);
	               }
	            if (filedone == 0)
	               {
	               printf("Please enter the name of the file to write -> ");
	               scanf("%s", hostname);
	               ((unsigned int *)datastring)[0] = 1235;
	               i = 0;
	               while ( i < 64)
	                  datastring[i+4] = hostname[i++];
	               if (send(socket_id, datastring, sizeof datastring, 0) == -1)
		          {
		          printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! SEND BROKEN\n");
		          continue;
		          }   
	               printf("Waiting for verification of remote file open.\n");
	               if ( recv(socket_id, datastring, sizeof datastring, 0) == NULL )
		          {
		          printf("RECV IS BROKEN (1)\n");
		          return 1;
		          }
	               if ( ((unsigned int *)datastring)[0] == 1 )
	                  {
	                  printf("Remote file could not be created.\n");
	                  filedone = 1;
	                  fclose(fp);
	                  }
	               else
	                  {
	                  printf("Remote file is open for writing\n");
	                  }
	               last = 0;
	               step = (int)(filesize / 10);
	               printf("\nPercent Done 0%%.");
	               }
	            
// Read and Transmitt File	            
	            while(!filedone)
		       {
		       last++;
		       if ( 64 > (data.control = fread(data.block, 1, 64, fp)) )
		          {
		          printf(".100%%\n");
	            	  printf("Last Block Transmitted.\n");
		          filedone = 1;
		          fclose(fp);
		          }
		       ((unsigned int *)datastring)[0] = data.control;
		       i = 0;
		       while ( i < 64 )
		          {
		          datastring[i+4] = data.block[i];
		          i++;
		          }
		       if ( (last * 64) > step )
		          {
		          printf(".");
		          fflush(stdout);
		          last = 0;
		          }
		       if ( send(socket_id, datastring, sizeof datastring, 0) == NULL )
		          {
		          printf("SEND IS BROKEN (1)\n");
		          return 1;
		          }
		       if ( recv(socket_id, datastring, sizeof datastring, 0) == NULL )
		          {
		          printf("SEND IS BROKEN (1)\n");
		          return 1;
		          }
		       }
	            break;
	            
// Decode Encrypted File	            
	            case 'd':
	            printf("Entering Decryption Mode.\n\n");
	            printf("Please enter the filename to be decrypted -> ");
	            scanf("%s", hostname);
	            filedone = 0;
	            if((fp = fopen(hostname, "rb")) == NULL)
		       {
		       printf("File %s could not be opened.\n", hostname);
		       filedone = 1;
		       }
	            else	
	               {
	               filesize = get_file_size(hostname);
	               }

// Open Key File
	            strcat(hostname, ".key");
	            if((fp3 = fopen(hostname, "rb")) == NULL)
		       {
		       printf("Key file could not be found.\n", hostname);
		       filedone = 1;
		       fclose(fp);
		       }

// Open Destination File
	            if (filedone == 0)
	               {
	               printf("Please enter the name of the file to write -> ");
	               scanf("%s", hostname);
	               if((fp2 = fopen(hostname, "wb")) == NULL)
		          {
		          printf("File %s could not be opened.\n", hostname);
		          filedone = 1;
		          fclose(fp);
		          fclose(fp3);
		          }
	               fread(key_iv, 1, sizeof key_iv, fp3);
	               fread(DES_Key_B, 1, sizeof DES_Key_B, fp3);
	               fclose(fp3);
	               last = 0;
	               step = (int)(filesize / 10);
	               printf("\nPercent Done 0%%.");
	               }

// Process All Blocks
	            while(!filedone)
	               {
	               fread(((unsigned int *)datastring), 4, 1, fp);
	               fread(data.block, 1, 64, fp);
	               if ( 64 > ((unsigned int *)datastring)[0] )
		          {
		          printf(".100%%\n");
		          printf("Last Block Decoded.\n");
		          filedone = 1;
		          fclose(fp);
		          }
		       last++;
		       if ( (last * 64) > step )
		          {
		          printf(".");
		          fflush(stdout);
		          last = 0;
		          }
		       if ( (status = DESDecrypt( key_iv, DES_Key_B, ECB_MODE, data.block,
                        64 )) != SUCCESS )
    		          {
           	          printf("Can not decrypt block.\n");
        	          return status;
    		          }
    		       fwrite(data.block, 1, ((unsigned int *)datastring)[0], fp2);
	               if ( ((unsigned int *)datastring)[0] != 64 )
	                  {
	                  filedone = 1;
	                  fclose(fp2);
	                  }
    		       }
	            
	            break;
	            
	            case 'e':
	            printf("Entering Encryption Mode.\n\n");
	            printf("Please enter the file name to send -> ");
	            scanf("%s", hostname);
	            filedone = 0;
	            if((fp = fopen(hostname, "rb")) == NULL)
		       {
		       printf("File %s could not be opened.\n", hostname);
		       filedone = 1;
		       }
		    filesize = get_file_size(hostname);
	            if (filedone == 0)
	               {
	               printf("Please enter the name of the file to write -> ");
	               scanf("%s", hostname);
	               ((unsigned int *)datastring)[0] = 1236;
	               i = 0;
	               while ( i < 64)
	                  datastring[i+4] = hostname[i++];
	               if (send(socket_id, datastring, sizeof datastring, 0) == -1)
		          {
		          printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! SEND BROKEN\n");
		          continue;
		          }   
	               if ( recv(socket_id, datastring, sizeof datastring, 0) == NULL )
		          {
		          printf("RECV IS BROKEN (1)\n");
		          return 1;
		          }
	               if ( ((unsigned int *)datastring)[0] == 1 )
	                  {
	                  printf("Remote file could not be created.\n");
	                  filedone = 1;
	                  fclose(fp);
	                  }

// Generate Encryption Keys	               
	               InitRand( (ushort)strlen((char*)seed), seed, RVAL );
	               if ( (status = GenDHPair( 64, DH_secret_A, DH_public_A,
        		(uchar *)DH_base, (uchar *)DH_modulus, RVAL)) != SUCCESS)
    			  {
        		  printf("Can not generate DH pair.\n");
        		  return status;
    			  }
	               printf("Preparing to send public key.\n");
	               if ( send(socket_id, DH_public_A, sizeof DH_public_A, 0) == NULL )
		          {
		          printf("SEND IS BROKEN (1)\n");
		          return 1;
		          }
	               printf("Preparing to recv public key.\n");
	               if ( recv(socket_id, DH_public_B, sizeof DH_public_B, 0) == NULL )
		          {
		          printf("Recv IS BROKEN (1)\n");
		          return 1;
		          }
	               if ( (status = GetDHSharedNumber( 64, DH_secret_A, DH_public_B,
           		DH_shared_A, (uchar *)DH_modulus)) != SUCCESS)
    			  {
        		  printf("Can not generated shared number.\n");
        	          return status;
    			  }
	               if ( (status = SetCipherKey( 64, DH_shared_A, Key_A, DES56_ECB ))
                        !=SUCCESS)
    			  {
        		  printf("Can not generate cipher key.\n");
        		  return status;
    			  }
	               DESKeyExpand( Key_A, DES_Key_A );
// Keys Generated	               
	               last = 0;
	               step = (int)(filesize / 10);
	               printf("\nPercent Done 0%%.");
	               }
	            
// Read and Transmitt File	            
	            while(!filedone)
		       {
		       if ( 64 > (data.control = fread(data.block, 1, 64, fp)) )
		          {
		          printf(".100%%\n");
		          printf("Last Block Transmitted\n");
		          filedone = 1;
		          fclose(fp);
		          }
		       ((unsigned int *)datastring)[0] = data.control;
		       if ( (status = DESEncrypt( key_iv, DES_Key_A, ECB_MODE, data.block,
             		data.block, 64 )) != SUCCESS )
    			  {
        		  printf("Can not encrypt block.\n");
        		  return status;
    			  }
		       i = 0;
		       while ( i < 64 )
		          {
		          datastring[i+4] = data.block[i];
		          i++;
		          }
		       last++;
		       if ( (last * 64) > step )
		          {
		          printf(".");
		          fflush(stdout);
		          last = 0;
		          }
		       if ( send(socket_id, datastring, sizeof datastring, 0) == NULL )
		          {
		          printf("SEND IS BROKEN (1)\n");
		          return 1;
		          }
		       if ( recv(socket_id, datastring, sizeof datastring, 0) == NULL )
		          {
		          printf("SEND IS BROKEN (1)\n");
		          return 1;
		          }
		       }
		    break;
	            }

// If not done, Redisplay menu.
	         if (done != 1)
	            {
	            printf("\nPausing...\n\n");
		    system("sleep 4");
	            system("clear");
	            printf("Here is the menu!!\nThis should redisplay after every command.\n");
	            printf("Options are:\n\t'q' - Quit both machines\n\t's' - Send File\n\t");
	            printf("'e' - Encrypted File Send\n\t'd' - Decrypt Sent File\n\t -> ");
	            }
	         }
	      }
	((unsigned int *)datastring)[0] = 1234;
	if (send(socket_id, datastring, sizeof datastring, 0) == -1)
	    	{
	    	printf("AAAARRRRGGGGHHHHHH THE PAIN!!!! SEND BROKEN\n");
	   	}
	done = 1;
	shutdown(new_fd, 2);
	shutdown(socket_id, 2);
	fclose(fp);
	fclose(fp2);
	}
